// ClassFactory.cpp: Implementierung der Klasse CClassFactory.
//
//////////////////////////////////////////////////////////////////////

//#include "stdafx.h"
#define STRICT
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <limits.h>

#include "unzip32dll.h"
#define INITGUID
#include <objbase.h>
#include <shlobj.h>
#include "ZIPShellExt.h"
#include "ClassFactory.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

LONG        g_cRef = 0;

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CClassFactory::CClassFactory()
{
    m_cRef = 0L;
    InterlockedIncrement( &g_cRef );
}

CClassFactory::~CClassFactory()
{
    InterlockedDecrement( &g_cRef );
}

// IUnknown
STDMETHODIMP CClassFactory::QueryInterface(REFIID riid,LPVOID* ppv )
{
    *ppv = NULL;
    if(IsEqualIID( riid, IID_IUnknown ))
    {   *ppv = (LPUNKNOWN)this;
        m_cRef++;
        return NOERROR;
    }
    else if(IsEqualIID( riid, IID_IClassFactory ))
    {   *ppv = (LPCLASSFACTORY)this;
        m_cRef++;
        return NOERROR;
    }
    else
        return ResultFromScode( E_NOINTERFACE );

}

STDMETHODIMP_(ULONG) CClassFactory::AddRef()
{
    return(++m_cRef);
}

STDMETHODIMP_(ULONG) CClassFactory::Release()
{
    if( --m_cRef )
        return m_cRef;

    delete this;
    return 0L;
}

// IClassFactory
STDMETHODIMP CClassFactory::CreateInstance(LPUNKNOWN punk,REFIID riid,LPVOID* ppv)
{
    *ppv = NULL;
    if( punk != NULL )
        return ResultFromScode( CLASS_E_NOAGGREGATION );

    CZIPShellExt* pShellExt = new CZIPShellExt;
    if( pShellExt == NULL )
        return ResultFromScode( E_OUTOFMEMORY );

    return pShellExt->QueryInterface( riid, ppv );
}

STDMETHODIMP CClassFactory::LockServer( BOOL f )
{
    if(f)
        InterlockedIncrement(&g_cRef);
    else
        InterlockedDecrement(&g_cRef);

    return NOERROR;
}

