/* ComnDlg.c - File contains all regarding the View Comment Dialog */

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commctrl.h>
#include <stdlib.h>
#include "unzip32dll.h"
#include "resource.h"
#include "Dialog.h"

HINSTANCE        g_hInst;
HINSTANCE        hUnzip32Dll;
_DLL_UNZIP        windll_unzip;
USERFUNCTIONS    UserFunctions;
ZIPMessage        *Messages;

void OnViewComment(HWND hwndDlg)
{   ZIPShellDlgData    *pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);
    char    *buffer1,*buffer2;
    int        i=0,j=0;
    ZIPMessage    *ptr1,*ptr2=Messages;

    if(!hUnzip32Dll)
        hUnzip32Dll=LoadLibrary(UNZ_DLL_NAME);
    
    if(hUnzip32Dll==NULL)
    {   buffer1=(char*)malloc(32*sizeof(char));
        LoadString(g_hInst,IDS_ERROR_MSG3,buffer1,32);
        MessageBox(hwndDlg,buffer1,"Error",MB_ICONERROR|MB_OK);
        free(buffer1);
    }
    else
    {   if(!windll_unzip)
            windll_unzip=(_DLL_UNZIP)GetProcAddress(hUnzip32Dll,"windll_unzip");

        buffer1=pDlgData->DCLBlock.lpszZipFN;
        memset(&pDlgData->DCLBlock,0,sizeof(DCL));
        pDlgData->DCLBlock.lpszZipFN=buffer1;
        pDlgData->DCLBlock.nzflag=TRUE;
/*        UserFunctions.print=&ZIPPrint;*/
        Messages=NULL;
        windll_unzip(0,NULL,&pDlgData->DCLBlock,&UserFunctions);
/*        FreeLibrary(hUnzip32Dll);*/

        ptr1=Messages;
        Messages=ptr2;

        buffer1=ptr1->string;

        /* make -a conversion on the comment to keep WIN happy */
        buffer2=(char*)malloc(2*strlen(buffer1)*sizeof(char));    /* suppose the whole buffer1 consists of LF */
        *buffer2='\0';

        while(buffer1[i])
        {
            if(buffer1[i]=='\r' && buffer1[i+1]!='\n')    /* CR without LF */
            {   buffer2[j++]=buffer1[i++];
                buffer2[j++]='\n';
            }
            else if(buffer1[i]=='\n' && buffer1[i+1]!='\r') /* LF without CR */
            {   buffer2[j++]='\r';
                buffer2[j++]=buffer1[i++];
            }

            buffer2[j++]=buffer1[i++];
        
        }

        buffer2[j]='\0';

        while(ptr1!=NULL)
        {   ptr2=ptr1->Next;
            free(ptr1);
            ptr1=ptr2;
        }

        DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_COMMENT),hwndDlg,CommentDlgProc,(LPARAM)buffer2);

        free(buffer2);
    }
}

BOOL APIENTRY CommentDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
    switch(message)
    {   case    WM_INITDIALOG:
            SendDlgItemMessage(hwndDlg,IDC_COMMENT,WM_SETTEXT,0,(LPARAM)lParam);
        break;
        case    WM_CLOSE:
            EndDialog(hwndDlg,0);
        break;
/*        case    WM_COMMAND:
            if(LOWORD(wParam)==IDOK)
                EndDialog(hwndDlg,0);
            else
                return(FALSE);
        break;*/
        default:
            return(FALSE);
    }
    return(TRUE);
}
