/* Dialog.c    */

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <limits.h>
#include "unzip32dll.h"
#include "Dialog.h"
#include "resource.h"

HINSTANCE        g_hInst;
HINSTANCE        hUnzip32Dll;
_DLL_UNZIP       windll_unzip;
_DLL_VERSION     lUzpVersion;   /* UzpVersion already defined in unzip.h as a funktion */
USERFUNCTIONS    UserFunctions;
ZIPMessage       *Messages;
ZIPEntry         *Entries;
UzpVer           UnzipVersion;

BOOL APIENTRY PropDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam)
{   NMHDR    *nmhdr;
    ZIPShellDlgData    *pDlgData;
    ZIPEntry    *ptr1a,*ptr1b;
    ZIPMessage    *ptr2a,*ptr2b;

    switch (message)
    {   case    WM_INITDIALOG:
            OnInitDialog(hwndDlg,lParam);
        break;
        case    WM_DESTROY:
            if(hUnzip32Dll)
            {   FreeLibrary(hUnzip32Dll);
                hUnzip32Dll=NULL;
            }
            windll_unzip=NULL;

            pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);

            ptr1a=pDlgData->Entries;
            while(ptr1a)
            {   ptr1b=ptr1a->Next;
                free(ptr1a);
                ptr1a=ptr1b;
            }
            pDlgData->Entries=NULL;

            ptr2a=pDlgData->Messages;
            while(ptr2a)
            {   ptr2b=ptr2a->Next;
                free(ptr2a);
                ptr2a=ptr2b;
            }
            pDlgData->Messages=NULL;

            ImageList_Destroy(pDlgData->hNormalImageList);
            ImageList_Destroy(pDlgData->hSmallImageList);
            DestroyMenu(pDlgData->hPopupMenu);
        break;
        case    WM_CONTEXTMENU:
            pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);
            TrackPopupMenu(pDlgData->hPopupMenu,TPM_CENTERALIGN|TPM_RIGHTBUTTON,LOWORD(lParam),HIWORD(lParam),0,hwndDlg,NULL);
        break;
        case    WM_NOTIFY:
            if(LOWORD(wParam)=IDC_LIST)
            {   nmhdr=&((LV_DISPINFO*)lParam)->hdr;
                switch(((LV_DISPINFO*)lParam)->hdr.code)
                {    case    LVN_GETDISPINFO:
                        OnGetdispinfoList(hwndDlg,(LV_DISPINFO*)lParam);
                    break;
                    case    PSN_KILLACTIVE:
                        nmhdr=(NMHDR*)lParam;
                    break;
                    case    PSN_APPLY:
                    break;
                    default:
                        return(FALSE);
                }
            }
            else
                return(FALSE);
        break;
        case    WM_COMMAND:
            switch(LOWORD(wParam))
            {   case    IDM_REPORT:
                    OnStyle(hwndDlg,LVS_REPORT);
                break;
                case    IDM_LARGE_ICON:
                    OnStyle(hwndDlg,LVS_ICON);
                break;
                case    IDM_SMALL_ICON:
                    OnStyle(hwndDlg,LVS_SMALLICON);
                break;
                case    IDM_LIST:
                    OnStyle(hwndDlg,LVS_LIST);
                break;
                case    IDM_EXTRACT:
                    OnExtract(hwndDlg);
                break;
                case    IDM_OPTIONS:
                    pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);
                    if(IDOK==DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_OPTIONS),hwndDlg,OptionsDlgProc,(LPARAM)pDlgData))
                        AdjColumns(hwndDlg);
                break;
                case    IDM_COMMENT:
                    OnViewComment(hwndDlg);
                break;
                default:
                    return(FALSE);
            }
        break;
        case    PSM_APPLY:
            nmhdr=(NMHDR*)lParam;
        break;
        default:
            return(FALSE); 
    } 
    return(TRUE);
}

/* modified from AfxPropPageCallback in dlgprop.cpp to be called from the Explorer in the dll, see 
   top of this file */
UINT CALLBACK PropPageCallback(HWND hwndPage,UINT message,LPPROPSHEETPAGE pPropPage)
{        
    switch (message)
    {   case PSPCB_CREATE:
        {
/*            ASSERT(AfxIsValidAddress(pPropPage, sizeof(PROPSHEETPAGE)));
            CPropertyPage* pPage =
                STATIC_DOWNCAST(CPropertyPage, (CObject*)pPropPage->lParam);
            ASSERT_VALID(pPage);
            TRY
            {
                AfxHookWindowCreate(pPage);
            }
            CATCH_ALL(e)
            {
                // Note: DELETE_EXCEPTION(e) not necessary
                return FALSE;
            }
            END_CATCH_ALL*/
        }
            return TRUE;

        case PSPCB_RELEASE:
//            AfxUnhookWindowCreate();
        break;
    }

    return 0;
}

BOOL OnInitDialog(HWND hwndDlg,LPARAM lParam)
{   ZIPShellDlgData    *pDlgData=(ZIPShellDlgData*)((PROPSHEETPAGE*)lParam)->lParam;
    RECT        rect={0,0,0,0};
    ZIPEntry    *ptr=pDlgData->Entries;
    SHFILEINFO    shFile;
    HIMAGELIST    hImageList;
    HICON        hIcon;
    HWND        hListCtrl=GetDlgItem(hwndDlg,IDC_LIST);
    LV_ITEM        item;
    int            i,Index,cx,cy;
/*    WORD        IconIndex;*/
    char        buffer[50]="d:\\temp\\xwinedt.zip",*t1,*t2;
    DWORD        dwType=0,dwCount=sizeof(buffer),dwError;
    HMENU        hMenu;
    COLORREF    color;

    SetWindowLong(hwndDlg,GWL_USERDATA,(LONG)pDlgData);

    hMenu=LoadMenu(g_hInst,MAKEINTRESOURCE(IDM_POPUPMENU));
    if(!hMenu)
        dwError=GetLastError();
    else
        pDlgData->hPopupMenu=GetSubMenu(hMenu,0);

    i=GetWindowLong(hListCtrl,GWL_STYLE);

    UncheckMenus(hwndDlg);

    if(LVS_REPORT&i)
        CheckMenuItem(pDlgData->hPopupMenu,IDM_REPORT,MF_BYCOMMAND|MF_CHECKED);
    else if(LVS_LIST&i)
        CheckMenuItem(pDlgData->hPopupMenu,IDM_LIST,MF_BYCOMMAND|MF_CHECKED);
    else if(LVS_ICON&i)
        CheckMenuItem(pDlgData->hPopupMenu,IDM_LARGE_ICON,MF_BYCOMMAND|MF_CHECKED);
    else if(LVS_SMALLICON&i)
        CheckMenuItem(pDlgData->hPopupMenu,IDM_SMALL_ICON,MF_BYCOMMAND|MF_CHECKED);

    shFile.dwAttributes=0;
    strncpy(shFile.szDisplayName,"test.bmp",MAX_PATH);
    hImageList=(HIMAGELIST)SHGetFileInfo("",0,&shFile,sizeof(SHFILEINFO),SHGFI_ICON|SHGFI_SYSICONINDEX);
    color=ImageList_GetBkColor(hImageList);
/*    ASSERT(hImageList);*/
    Index=ImageList_GetImageCount(hImageList);
    ImageList_GetIconSize(hImageList,&cx,&cy);

    pDlgData->hNormalImageList=ImageList_Create(cx,cy,ILC_COLOR,Index,20);
    ImageList_SetBkColor(pDlgData->hNormalImageList,color);
    color=ImageList_GetBkColor(pDlgData->hNormalImageList);

    for(i=0;i<min(Index,4);i++)
    {    hIcon=ImageList_GetIcon(hImageList,i,ILD_NORMAL);
        ImageList_AddIcon(pDlgData->hNormalImageList,hIcon);
    }
    color=ImageList_GetBkColor(pDlgData->hNormalImageList);
    
    if(!pDlgData->ExtList)
        pDlgData->ExtList=(ExtPair*)malloc(sizeof(ExtPair));

    strcpy(pDlgData->ExtList->Ext,"");                    // unknown
    pDlgData->ExtList->Index=3;
    pDlgData->ExtList->Next=(ExtPair*)malloc(sizeof(ExtPair));
    strncpy(pDlgData->ExtList->Next->Ext,"       ",8);    // folder
    pDlgData->ExtList->Next->Index=4;
    pDlgData->ExtList->Next->Next=NULL;

    hImageList=(HIMAGELIST)SHGetFileInfo("",0,&shFile,sizeof(SHFILEINFO),SHGFI_SYSICONINDEX|SHGFI_SMALLICON);
    color=ImageList_GetBkColor(hImageList);
//    ASSERT(hImageList);
    Index=ImageList_GetImageCount(hImageList);
    ImageList_GetIconSize(hImageList,&cx,&cy);

    pDlgData->hSmallImageList=ImageList_Create(cx,cy,ILC_COLOR,Index,20);
    ImageList_SetBkColor(pDlgData->hSmallImageList,color);
    
    for(i=0;i<min(Index,4);i++)
    {    hIcon=ImageList_GetIcon(hImageList,i,ILD_NORMAL);
        ImageList_AddIcon(pDlgData->hSmallImageList,hIcon);
    }

    ListView_SetImageList(hListCtrl,pDlgData->hNormalImageList,LVSIL_NORMAL);
    ListView_SetImageList(hListCtrl,pDlgData->hSmallImageList,LVSIL_SMALL);

#ifdef _DEBUG
    Index=ImageList_GetImageCount(pDlgData->hNormalImageList);
    Index=ImageList_GetImageCount(pDlgData->hSmallImageList);
#endif

    pDlgData->DCLBlock.nvflag=TRUE;

    if(!GetUnzipDll())
        return FALSE;

/*    UserFunctions.print=&ZIPPrint;
    UserFunctions.sound=NULL;
    UserFunctions.replace=&GetReplaceDlgRetVal;
    UserFunctions.password=&GetPasswd;
    UserFunctions.SendApplicationMessage=&ReceiveDllMessage;*/

//    pDlgData->DCLBlock.lpszZipFN;
    windll_unzip(0,NULL,&pDlgData->DCLBlock,&UserFunctions);

    pDlgData->Entries=Entries;
    Index=UserFunctions.NumMembers;
    ListView_SetItemCount(hListCtrl,Index);
    AdjColumns(hwndDlg);

    if(UserFunctions.cchComment>0)
        EnableMenuItem(pDlgData->hPopupMenu,IDM_COMMENT,MF_BYCOMMAND|MF_ENABLED);

    i=0;
    ptr=pDlgData->Entries;
    while(ptr!=NULL)
    {
        if(ptr->crc==0)    /*directory*/
            Index=3;
        else
        {   strncpy(buffer,ptr->name,sizeof(buffer)-1);
    /*        t2=NULL;*/
            t1=strtok(buffer,".");
            do
            {   t2=t1;
                t1=strtok(NULL,".");            
            }while(t1!=NULL);

            *(--t2)='.';
//            Index=GetIconIndex(hwndDlg,t2);
            if(stricmp(t2,".exe"))
                Index=0;
            else
                Index=2;
        }

/*        m_ListCtrl.InsertItem(LVIF_TEXT|LVIF_IMAGE|LVIF_PARAM,i,ptr->name,0,0,Index,(long)ptr);*/
        item.mask=LVIF_TEXT|LVIF_IMAGE|LVIF_PARAM;
        item.iItem=i;
        item.iSubItem=0;
        item.pszText=ptr->name;
        item.state=0;
        item.stateMask=0;
        item.iImage=Index;
        item.lParam =(long)ptr;
        Index=ListView_InsertItem(hListCtrl,&item);
/*        dx=max(dx,ListView_GetStringWidth(hListCtrl,ptr->name));
        itoa(ptr->len,buffer,10);
        m_ListCtrl.SetItemText(i,1,buffer);
    
        itoa(ptr->size,buffer,10);
        m_ListCtrl.SetItemText(i,2,buffer);
    
        itoa(ptr->ratio,buffer,10);
        m_ListCtrl.SetItemText(i,3,buffer);
*/    
        ptr=ptr->Next;
        i++;

    }

    ListView_SetColumnWidth(hListCtrl,0,LVSCW_AUTOSIZE);

    return TRUE;  // return TRUE  unless you set the focus to a control
}

void OnGetdispinfoList(HWND hwndDlg,LV_DISPINFO *pDispInfo) 
{   ZIPShellDlgData    *pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);

/*    LV_DISPINFO *pDispInfo = (LV_DISPINFO*)pNMHDR;
    ASSERT(pDispInfo);*/
    LV_ITEM        *pItem=&(pDispInfo->item);    
    ZIPEntry    *ptr=(ZIPEntry*)pItem->lParam;
    char        *buffer;
    
    if(pItem->mask&LVIF_TEXT)
    {   buffer=(char*)malloc(pItem->cchTextMax*sizeof(char));

        if(pItem->iSubItem==0)
            strncpy(pItem->pszText,ptr->name,pItem->cchTextMax-1);
        else if(pItem->iSubItem==pDlgData->SubItem_Size)
            strncpy(pItem->pszText,itoa(ptr->len,buffer,10),pItem->cchTextMax-1);
        else if(pItem->iSubItem==pDlgData->SubItem_CSize)
            strncpy(pItem->pszText,itoa(ptr->size,buffer,10),pItem->cchTextMax-1);
        else if(pItem->iSubItem==pDlgData->SubItem_Ratio)
            strncpy(pItem->pszText,itoa(ptr->ratio,buffer,10),pItem->cchTextMax-1);
        else if(pItem->iSubItem==pDlgData->SubItem_Date)
        {    sprintf(buffer,"%u/%u/%u",ptr->day,ptr->month,ptr->year);
            strncpy(pItem->pszText,buffer,pItem->cchTextMax-1);
        }
        else if(pItem->iSubItem==pDlgData->SubItem_Time)
        {    sprintf(buffer,"%u:%u",ptr->hour,ptr->min);
            strncpy(pItem->pszText,buffer,pItem->cchTextMax-1);
        }
        else if(pItem->iSubItem==pDlgData->SubItem_CRC)
        {    sprintf(buffer,"%8X",ptr->crc);
            strncpy(pItem->pszText,buffer,pItem->cchTextMax-1);
        }
        else if(pItem->iSubItem==pDlgData->SubItem_Method)
            strncpy(pItem->pszText,ptr->method,min(METHOD_LEN,pItem->cchTextMax-1));

        free(buffer);
    }

}

void AdjColumns(HWND hwndDlg)
{   ZIPShellDlgData    *pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);
    LV_COLUMN    lvColumn;
    HWND        hList=GetDlgItem(hwndDlg,IDC_LIST);
    char        buffer[16];
    int            b=ListView_GetStringWidth(hList,itoa(INT_MAX,buffer,10))+8,
                i=1;

    lvColumn.mask=LVCF_SUBITEM;
    if(!ListView_GetColumn(hList,0,&lvColumn))
    {   LoadString(g_hInst,IDS_NAME,buffer,16);
        lvColumn.mask=LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
        lvColumn.fmt=LVCFMT_LEFT;
        lvColumn.cx=100;
        lvColumn.pszText=buffer;
        lvColumn.iSubItem=0;
        ListView_InsertColumn(hList,0,&lvColumn);
    }

    lvColumn.mask=LVCF_SUBITEM;
    while(ListView_GetColumn(hList,1,&lvColumn))
    {
        ListView_DeleteColumn(hList,1);
    }
    
    if(pDlgData->ColFlags&COL_SIZE && !ListView_GetColumn(hList,i,&lvColumn))
    {   LoadString(g_hInst,IDS_SIZE,buffer,16);
        pDlgData->SubItem_Size=i++;
        lvColumn.mask=LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
        lvColumn.fmt=LVCFMT_RIGHT;
        lvColumn.cx=b;
        lvColumn.pszText=buffer;
        lvColumn.iSubItem=pDlgData->SubItem_Size;
        ListView_InsertColumn(hList,pDlgData->SubItem_Size,&lvColumn);
        lvColumn.mask=LVCF_SUBITEM;
    }
    
    if(pDlgData->ColFlags&COL_CSIZE && !ListView_GetColumn(hList,i,&lvColumn))
    {   LoadString(g_hInst,IDS_CSIZE,buffer,16);
        pDlgData->SubItem_CSize=i++;
        lvColumn.mask=LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
        lvColumn.fmt=LVCFMT_RIGHT;
        lvColumn.cx=b;
        lvColumn.pszText=buffer;
        lvColumn.iSubItem=pDlgData->SubItem_CSize;
        ListView_InsertColumn(hList,pDlgData->SubItem_CSize,&lvColumn);
        lvColumn.mask=LVCF_SUBITEM;
    }
    
    if(pDlgData->ColFlags&COL_RATIO && !ListView_GetColumn(hList,i,&lvColumn))
    {   LoadString(g_hInst,IDS_RATIO,buffer,16);
        pDlgData->SubItem_Ratio=i++;
        lvColumn.mask=LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
        lvColumn.fmt=LVCFMT_RIGHT;
        lvColumn.cx=b;
        lvColumn.pszText=buffer;
        lvColumn.iSubItem=pDlgData->SubItem_Ratio;
        ListView_InsertColumn(hList,pDlgData->SubItem_Ratio,&lvColumn);
        lvColumn.mask=LVCF_SUBITEM;
    }

    if(pDlgData->ColFlags&COL_DATE && !ListView_GetColumn(hList,i,&lvColumn))
    {   LoadString(g_hInst,IDS_DATE,buffer,16);
        pDlgData->SubItem_Date=i++;
        lvColumn.mask=LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
        lvColumn.fmt=LVCFMT_RIGHT;
        lvColumn.cx=b;
        lvColumn.pszText=buffer;
        lvColumn.iSubItem=pDlgData->SubItem_Date;
        ListView_InsertColumn(hList,pDlgData->SubItem_Date,&lvColumn);
        lvColumn.mask=LVCF_SUBITEM;
    }

    if(pDlgData->ColFlags&COL_TIME && !ListView_GetColumn(hList,i,&lvColumn))
    {   LoadString(g_hInst,IDS_TIME,buffer,16);
        pDlgData->SubItem_Time=i++;
        lvColumn.mask=LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
        lvColumn.fmt=LVCFMT_RIGHT;
        lvColumn.cx=b;
        lvColumn.pszText=buffer;
        lvColumn.iSubItem=pDlgData->SubItem_Time;
        ListView_InsertColumn(hList,pDlgData->SubItem_Time,&lvColumn);
        lvColumn.mask=LVCF_SUBITEM;
    }

    if(pDlgData->ColFlags&COL_CRC && !ListView_GetColumn(hList,i,&lvColumn))
    {   LoadString(g_hInst,IDS_CRC,buffer,16);
        pDlgData->SubItem_CRC=i++;
        lvColumn.mask=LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
        lvColumn.fmt=LVCFMT_RIGHT;
        lvColumn.cx=b;
        lvColumn.pszText=buffer;
        lvColumn.iSubItem=pDlgData->SubItem_CRC;
        ListView_InsertColumn(hList,pDlgData->SubItem_CRC,&lvColumn);
        lvColumn.mask=LVCF_SUBITEM;
    }

    if(pDlgData->ColFlags&COL_METHOD && !ListView_GetColumn(hList,i,&lvColumn))
    {   LoadString(g_hInst,IDS_METHOD,buffer,16);
        pDlgData->SubItem_Method=i++;
        lvColumn.mask=LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
        lvColumn.fmt=LVCFMT_LEFT;
        lvColumn.cx=b;
        lvColumn.pszText=buffer;
        lvColumn.iSubItem=pDlgData->SubItem_Method;
        ListView_InsertColumn(hList,pDlgData->SubItem_Method,&lvColumn);
        lvColumn.mask=LVCF_SUBITEM;
    }

    InvalidateRect(hList,NULL,TRUE);
}

void OnStyle(HWND hwndDlg,LONG lStyle)
{   ZIPShellDlgData    *pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);
    HWND    hList=GetDlgItem(hwndDlg,IDC_LIST);
    LONG    lWnd=GetWindowLong(hList,GWL_STYLE);
    lStyle&=LVS_TYPEMASK;
    lWnd|=!LVS_TYPEMASK;
    SetWindowLong(hList,GWL_STYLE,lWnd|lStyle);
    UncheckMenus(hwndDlg);

    if(lStyle&LVS_ICON)
        CheckMenuItem(pDlgData->hPopupMenu,IDM_LARGE_ICON,MF_BYCOMMAND|MF_CHECKED);
    else if(lStyle&LVS_REPORT)
        CheckMenuItem(pDlgData->hPopupMenu,IDM_REPORT,MF_BYCOMMAND|MF_CHECKED);
    else if(lStyle&LVS_SMALLICON)
        CheckMenuItem(pDlgData->hPopupMenu,IDM_SMALL_ICON,MF_BYCOMMAND|MF_CHECKED);
    else if(lStyle&LVS_LIST)
        CheckMenuItem(pDlgData->hPopupMenu,IDM_LIST,MF_BYCOMMAND|MF_CHECKED);
}

void UncheckMenus(HWND hwndDlg)
{   ZIPShellDlgData    *pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);

    CheckMenuItem(pDlgData->hPopupMenu,IDM_REPORT,MF_BYCOMMAND|MF_UNCHECKED);
    CheckMenuItem(pDlgData->hPopupMenu,IDM_LARGE_ICON,MF_BYCOMMAND|MF_UNCHECKED);
    CheckMenuItem(pDlgData->hPopupMenu,IDM_LIST,MF_BYCOMMAND|MF_UNCHECKED);
    CheckMenuItem(pDlgData->hPopupMenu,IDM_SMALL_ICON,MF_BYCOMMAND|MF_UNCHECKED);
}

void OnExtract(HWND hwndDlg)
{   ZIPShellDlgData    *pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);
    OPENFILENAME    ofn;
    LV_ITEM            item;
    HWND            hListCtrl;
    char            pathbuffer[PATH_MAX+1],filebuffer[PATH_MAX+1],buffer[64],**argv;
    int                i,n;

    strncpy(pathbuffer,pDlgData->DCLBlock.lpszZipFN,sizeof(pathbuffer));
    *strrchr(pathbuffer,'\\')='\0';

    memset(&ofn,0,sizeof(OPENFILENAME));
    ofn.lStructSize=sizeof(OPENFILENAME);
    ofn.hwndOwner=hwndDlg;
    ofn.hInstance=g_hInst;
    ofn.lpstrCustomFilter=NULL;
    filebuffer[0]='\0';
    ofn.lpstrFile=filebuffer;
//    ofn.lpstrFile[0]=' ';
    ofn.nMaxFile=sizeof(filebuffer);
    ofn.lpstrInitialDir=pathbuffer;
    LoadString(g_hInst,IDS_DIRSELTITLE,buffer,sizeof(buffer));
    ofn.lpstrTitle=buffer;
    ofn.Flags=OFN_EXPLORER|OFN_LONGNAMES|OFN_NOVALIDATE|OFN_HIDEREADONLY;
/*    ofn.lpTemplateName=MAKEINTRESOURCE(IDD_MYDIRSEL);*/

    if(!GetSaveFileName(&ofn))
    {    
#ifdef    _DEBUG
        DWORD    ErrorCode=CommDlgExtendedError();
        if(CDERR_DIALOGFAILURE & ErrorCode);
#endif
        return;
    }
    else
    {   if(GetUnzipDll())
        {   
            windll_unzip=(_DLL_UNZIP)GetProcAddress(hUnzip32Dll,"windll_unzip");

            hListCtrl=GetDlgItem(hwndDlg,IDC_LIST);
            n=ListView_GetItemCount(hListCtrl);
            argv=malloc((n+1)*sizeof(char*));
            memset(argv,0,(n+1)*sizeof(char*));
            n=0;
            i=-1;
            while(0<(i=ListView_GetNextItem(hListCtrl,i,LVNI_SELECTED)))
            {   item.mask=LVIF_PARAM;
                item.iItem=i;
                ListView_GetItem(hListCtrl,&item);
                argv[n++]=((ZIPEntry*)item.lParam)->name;
            }
            ofn.lpstrFileTitle=pDlgData->DCLBlock.lpszZipFN;    /* FileTitle is in filebuffer */
            memset(&pDlgData->DCLBlock,0,sizeof(DCL));
            pDlgData->DCLBlock.lpszZipFN=ofn.lpstrFileTitle;
            pDlgData->DCLBlock.ndflag=TRUE;
            pDlgData->DCLBlock.noflag=TRUE;
            *strrchr(filebuffer,'\\')='\0';
            argv[n++]=filebuffer;
            UserFunctions.print=&ExtractPrint;
            windll_unzip(n-1,argv,&pDlgData->DCLBlock,&UserFunctions);
/*            FreeLibrary(hUnzip32Dll);*/
        }
    }

}

int GetIconIndex(HWND hwndDlg,LPSTR Ext)
{   ZIPShellDlgData    *pDlgData=(ZIPShellDlgData*)GetWindowLong(hwndDlg,GWL_USERDATA);
    int        i,Index;
    ExtPair    *ptr=pDlgData->ExtList,*ptr1;
    HKEY    hKey;
    HICON    hIcon;
    BYTE    *buffer,*b;
    DWORD    dwType,dwCount,dwSize=64;
    
    while(ptr!=NULL && 0!=stricmp(ptr->Ext,Ext+1))
    {    ptr1=ptr;
        ptr=ptr->Next;
    }

    if(!ptr)
    {   i=RegOpenKeyEx(HKEY_CLASSES_ROOT,Ext,0,KEY_READ,&hKey);
        if(i==ERROR_INVALID_FUNCTION || hKey==NULL)    // no association
            return(3);
        else
        {/*    ASSERT(ERROR_SUCCESS==i);
            buffer=new BYTE[dwSize];*/
            buffer=(BYTE*)malloc(dwSize*sizeof(BYTE));
            dwCount=dwSize;
            i=RegQueryValueEx(hKey,"",NULL,&dwType,buffer,&dwCount);
            if(i==ERROR_MORE_DATA)
            {/*    delete buffer;*/
                free(buffer);
                dwSize=dwCount;
/*                buffer=new BYTE[dwSize];*/
                buffer=(BYTE*)malloc(dwSize*sizeof(BYTE));
                
                ERROR_SUCCESS==RegQueryValueEx(hKey,"",NULL,&dwType,buffer,&dwCount);
            }/*else
                ASSERT(i==ERROR_SUCCESS);*/

            ERROR_SUCCESS==RegCloseKey(hKey);

            dwCount=strlen((char*)buffer)+14;        /* strlen("\\DefaultIcon")+1*/
            if(dwSize<dwCount)
            {   b=buffer;
                dwSize=dwCount;
/*                buffer=new BYTE[dwSize];*/
                buffer=(BYTE*)malloc(dwSize*sizeof(BYTE));
                strncpy((char*)buffer,(char*)b,dwSize);
//                delete b;
                free(b);
            }
            strncat((char*)buffer,"\\DefaultIcon",dwSize-strlen((char*)buffer)-1);
            dwCount=dwSize;
//            VERIFY(ERROR_SUCCESS==RegOpenKeyEx(HKEY_CLASSES_ROOT,(char*)buffer,0,KEY_READ,&hKey));
            if(ERROR_SUCCESS!=RegOpenKeyEx(HKEY_CLASSES_ROOT,(char*)buffer,0,KEY_READ,&hKey))
            {//    delete buffer;
                free(buffer);
                return(3);
            }
            i=RegQueryValueEx(hKey,"",NULL,&dwType,buffer,&dwCount);
            if(i==ERROR_MORE_DATA)
            {//    delete buffer;
                free(buffer);
                dwSize=dwCount;
//                buffer=new BYTE[dwSize];
                buffer=(BYTE*)malloc(dwSize*sizeof(BYTE));

            
                ERROR_SUCCESS==RegQueryValueEx(hKey,"",NULL,&dwType,buffer,&dwCount);
            }/*else
                ASSERT(i==ERROR_SUCCESS);*/
        
            ERROR_SUCCESS==RegCloseKey(hKey);

            if(dwType&REG_EXPAND_SZ)
            {//   b=new BYTE[dwSize];
                b=(BYTE*)malloc(dwSize*sizeof(BYTE));

                strncpy((char*)b,(char*)buffer,dwSize-1);
                if(dwSize<(dwCount=ExpandEnvironmentStrings((char*)b,(char*)buffer,dwSize)))
                {//    delete    buffer;
                    free(buffer);
                    dwSize=dwCount;
/*                    buffer=new BYTE[dwSize];*/
                    buffer=(BYTE*)malloc(dwSize*sizeof(BYTE));
                    ExpandEnvironmentStrings((char*)b,(char*)buffer,dwSize);
                }
            }
            if(buffer[0]=='%')    /*icon depends on contents, maybe in the next version*/
            {/*    delete buffer;*/
                free(buffer);
                return(3);
            }

            strtok((char*)buffer,",");
            Index=atoi(strtok(NULL,","));
            hIcon=ExtractIcon(g_hInst,(char*)buffer,Index);
/*            delete buffer;*/
            free(buffer);
            if(hIcon==NULL | (int)hIcon==1)
                return(3);

            Index=ImageList_AddIcon(pDlgData->hNormalImageList,hIcon);
            Index=ImageList_AddIcon(pDlgData->hSmallImageList,hIcon);

            ptr=ptr1->Next=(ExtPair*)malloc(sizeof(ExtPair));
            strncpy(ptr->Ext,Ext+1,7);
            ptr->Index=Index;
            ptr->Next=NULL;
        
            return Index ;
        }

    }else
        return ptr->Index;
}

/* Callback-Functions for windll_unzip */

/* Standard callback which logs messages */
int WINAPI ZIPPrint(char *buffer, unsigned long size)
{   ZIPMessage    *ptr=Messages;
    
    if(!ptr)
        ptr=Messages=(ZIPMessage*)malloc(sizeof(ZIPMessage)+size+1);
    else
    {    while(ptr->Next)
            ptr=ptr->Next;

        ptr=ptr->Next=(ZIPMessage*)malloc(sizeof(ZIPMessage)+size+1);
    }

    ptr->string=(char*)ptr+sizeof(ZIPMessage);
    strcpy(ptr->string,buffer);
    ptr->Next=NULL;

    return size;
}

/* special callback for messages appearing during extraction */
int WINAPI ExtractPrint(char *buffer, unsigned long size)
{
    if(size>2)
        MessageBox(NULL,buffer,"Message from unzip",strstr(buffer,"Error")?MB_ICONERROR|MB_OK:MB_ICONINFORMATION|MB_OK);

    return size;
}

int WINAPI DisplayBuf(char *buffer, unsigned long size)
{
    return size;
}

void WINAPI ReceiveDllMessage(unsigned long ucsize,unsigned long csize,ush cfactor,ush mo,ush dy,ush yr,ush hh,ush mm,char c,char *filename,char *methbuf,unsigned long crc)
{   ZIPEntry    *ptr=Entries;

    if(!ptr)
    {   ptr=Entries=(ZIPEntry*)malloc(sizeof(ZIPEntry)+strlen(filename)+1);
        strncpy(ptr->method,methbuf,METHOD_LEN);

    }
    else
    {   while(ptr->Next)
            ptr=ptr->Next;
    
        ptr=ptr->Next=(ZIPEntry*)malloc(sizeof(ZIPEntry)+strlen(filename)+1);
        strncpy(ptr->method,methbuf,METHOD_LEN);
    }

    ptr->name=(char*)ptr+sizeof(ZIPEntry);
    strcpy(ptr->name,filename);

    ptr->len=ucsize;
    ptr->size=csize;
    ptr->ratio=cfactor;
    ptr->day=dy&0xff;
    ptr->month=mo&0xff;
    ptr->year=yr;
    ptr->hour=hh&0xff;
    ptr->min=mm&0xff;
    ptr->crc=crc;
    ptr->Next=NULL;

}
